/* Copyright (C) 2014 SpringSource
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.grails.datastore.gorm.mongo.geo

import grails.mongodb.geo.MultiPolygon

/**
 * Adds support for the {@link grails.mongodb.geo.MultiPolygon} type to GORM for MongoDB
 *
 * @author Graeme Rocher
 * @since 3.0
 */
class MultiPolygonType extends GeoJSONType<MultiPolygon>{
    MultiPolygonType() {
        super(MultiPolygon)
    }

    @Override
    MultiPolygon createFromCoords(List coords) {
        MultiPolygon.valueOf(coords)
    }
}
