/*
 * Copyright 2017-2020 original authors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.grails.forge.options;

import org.grails.forge.application.Project;

/**
 * Defines an abstract class to be extended to provide a{ @link RockerModel} to create {@link com.fizzed.rocker.RockerTemplate} for tests generated by the CLI and Launch for the different {@link Language} and {@link TestFramework} valid combinations.
 * @author Sergio del Amo
 */
public abstract class AbstractTestRockerModelProvider extends AbstractJunitRockerModelProvider
        implements TestRockerModelProvider {

    public AbstractTestRockerModelProvider(Project project) {
        super(project);
    }
}
