/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 *
 *    https://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package grails.plugin.geb

import groovy.transform.CompileStatic
import org.openqa.selenium.remote.FileDetector

/**
 * An extension of {@link org.openqa.selenium.remote.FileDetector}
 * that will get passed additional parameters from the webdriver container holder. 
 * <p>
 * Implementations must provide a zero-argument constructor to ensure compatibility with {@link java.util.ServiceLoader}.
 *
 * @see GebRecordingTestListener
 */
@CompileStatic
interface ContainerFileDetector extends FileDetector {
}
